// Package calendar code generated by oapi sdk gen
/*
 * MIT License
 *
 * Copyright (c) 2022 Lark Technologies Pte. Ltd.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice, shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

package larkcalendar

import (
	"context"
)

// 消息处理器定义
type P2CalendarChangedV4Handler struct {
	handler func(context.Context, *P2CalendarChangedV4) error
}

func NewP2CalendarChangedV4Handler(handler func(context.Context, *P2CalendarChangedV4) error) *P2CalendarChangedV4Handler {
	h := &P2CalendarChangedV4Handler{handler: handler}
	return h
}

// 返回事件的消息体的实例，用于反序列化用
func (h *P2CalendarChangedV4Handler) Event() interface{} {
	return &P2CalendarChangedV4{}
}

// 回调开发者注册的handle
func (h *P2CalendarChangedV4Handler) Handle(ctx context.Context, event interface{}) error {
	return h.handler(ctx, event.(*P2CalendarChangedV4))
}

// 消息处理器定义
type P2CalendarAclCreatedV4Handler struct {
	handler func(context.Context, *P2CalendarAclCreatedV4) error
}

func NewP2CalendarAclCreatedV4Handler(handler func(context.Context, *P2CalendarAclCreatedV4) error) *P2CalendarAclCreatedV4Handler {
	h := &P2CalendarAclCreatedV4Handler{handler: handler}
	return h
}

// 返回事件的消息体的实例，用于反序列化用
func (h *P2CalendarAclCreatedV4Handler) Event() interface{} {
	return &P2CalendarAclCreatedV4{}
}

// 回调开发者注册的handle
func (h *P2CalendarAclCreatedV4Handler) Handle(ctx context.Context, event interface{}) error {
	return h.handler(ctx, event.(*P2CalendarAclCreatedV4))
}

// 消息处理器定义
type P2CalendarAclDeletedV4Handler struct {
	handler func(context.Context, *P2CalendarAclDeletedV4) error
}

func NewP2CalendarAclDeletedV4Handler(handler func(context.Context, *P2CalendarAclDeletedV4) error) *P2CalendarAclDeletedV4Handler {
	h := &P2CalendarAclDeletedV4Handler{handler: handler}
	return h
}

// 返回事件的消息体的实例，用于反序列化用
func (h *P2CalendarAclDeletedV4Handler) Event() interface{} {
	return &P2CalendarAclDeletedV4{}
}

// 回调开发者注册的handle
func (h *P2CalendarAclDeletedV4Handler) Handle(ctx context.Context, event interface{}) error {
	return h.handler(ctx, event.(*P2CalendarAclDeletedV4))
}

// 消息处理器定义
type P2CalendarEventChangedV4Handler struct {
	handler func(context.Context, *P2CalendarEventChangedV4) error
}

func NewP2CalendarEventChangedV4Handler(handler func(context.Context, *P2CalendarEventChangedV4) error) *P2CalendarEventChangedV4Handler {
	h := &P2CalendarEventChangedV4Handler{handler: handler}
	return h
}

// 返回事件的消息体的实例，用于反序列化用
func (h *P2CalendarEventChangedV4Handler) Event() interface{} {
	return &P2CalendarEventChangedV4{}
}

// 回调开发者注册的handle
func (h *P2CalendarEventChangedV4Handler) Handle(ctx context.Context, event interface{}) error {
	return h.handler(ctx, event.(*P2CalendarEventChangedV4))
}
